DECLARE @timeZoneMigrationKey NVARCHAR(250) = N'CampaignTimeZoneMigrationTo7120';
DECLARE @objectDataJson VARCHAR(250) = N'{"CampaignTimeZoneMigrationTo7120":true}';

BEGIN
	IF OBJECT_ID('Campaign') IS NULL
	BEGIN
		RETURN;
	END;

	BEGIN TRANSACTION;

	BEGIN TRY
		IF NOT EXISTS(SELECT Id FROM SysProfileData
			WHERE [Key] = @timeZoneMigrationKey)
		BEGIN
			INSERT INTO SysProfileData([Key], ObjectData, ContactId)
			SELECT DISTINCT
				@timeZoneMigrationKey,
				CONVERT(VARBINARY(MAX), @objectDataJson),
				cont.Id FROM Campaign cmgn, Contact cont, SysSchema ss
			WHERE 
				(ss.ManagerName = N'CampaignSchemaManager'
					AND (ss.CreatedById = cont.Id
						OR ss.ModifiedById = cont.Id))
				OR cont.Id = cmgn.ModifiedById
				OR cont.Id = cmgn.CreatedById
				OR cont.Id = cmgn.OwnerId;
		END;
	END TRY
	BEGIN CATCH
		IF @@TRANCOUNT > 0
		BEGIN
			ROLLBACK TRANSACTION;
		END;
	END CATCH;

	IF @@TRANCOUNT > 0
	BEGIN
		COMMIT TRANSACTION;
	END;
END;