DECLARE @content varchar(max);
DECLARE @recordId uniqueidentifier;
DECLARE @position bigint;
DECLARE @fix varchar(500) = ', { "operation": "insert", "parentName": "HistoryTab", "propertyName": "items", "index": 0, "name": "LeadPageDistributionInfo", "values": { "itemType": Terrasoft.ViewItemType.CONTROL_GROUP, "items": [] } }, { "operation": "insert", "parentName": "LeadPageDistributionInfo", "propertyName": "items",  "name": "LeadPageDistributionInfoBlock", "values": { "itemType": Terrasoft.ViewItemType.GRID_LAYOUT, "items": [] } }';

IF EXISTS(SELECT 1
FROM SysSchemaContent ssc
    JOIN SysSchema ss ON ssc.SysSchemaId = ss.Id
    JOIN SysPackage sp ON ss.SysPackageId = sp.Id
WHERE ss.Name LIKE '%Lead%'
    AND sp.Maintainer <> 'Terrasoft'
    AND (
    ssc.Content LIKE '%LeadPageDistributionInfo%'
    OR ssc.Content LIKE '%LeadPageDistributionInfoBlock%'))
BEGIN

	SELECT @recordId = ssc.Id, @content = CAST(ssc.Content as varchar(max))
	FROM SysSchemaContent ssc (nolock)
		JOIN SysSchema (nolock) ss ON ssc.SysSchemaId = ss.Id
		JOIN SysPackage (nolock) sp ON ss.SysPackageId = sp.Id
	WHERE ss.Name LIKE 'LeadPageV2'
		AND sp.Id = (select Id from SysPackage where Name = 'Lead')
		AND NOT (
		ssc.Content LIKE '%LeadPageDistributionInfo%'
		OR ssc.Content LIKE '%LeadPageDistributionInfoBlock%')

	IF (@content is not NULL)
	BEGIN
		select @position = PATINDEX('%]/**SCHEMA_DIFF*/%', @content);
		IF (@position > 0)
		BEGIN
			select @content = STUFF(@content, @position, 0, @fix);
			update SysSchemaContent set Content = CAST(@content as varbinary(max)) where Id = @recordId;
		END
	END	
END

