﻿IF (SELECT TOP (1) 1 FROM SysLic) IS NULL
	RETURN;

DECLARE @Id UNIQUEIDENTIFIER;
DECLARE @Name NVARCHAR(MAX);
DECLARE @TableName SYSNAME;

DECLARE @DropTriggerCmd NVARCHAR(MAX),
		@DropTriggerCmdTemplate NVARCHAR(MAX) =
'IF OBJECT_ID(''CheckValueUpdate{TableName}'') IS NOT NULL
	DROP TRIGGER CheckValueUpdate{TableName};';

DECLARE @UpdateCmd NVARCHAR(MAX),
		@UpdateCmdTemplate NVARCHAR(MAX) =
'UPDATE @TableName
	SET Name = N''@Name''
WHERE Id = ''@Id'';';

-- Update statement cursor
DECLARE restoreLookupCursor CURSOR LOCAL FOR
	SELECT DISTINCT 
		slvb.Id, 
		slvb.Name, 
		slvb.TableName
	FROM SysLookupsValues_Backup slvb,
		(SELECT
			Id, 
			MIN(CreatedOn) AS CreatedOn
		FROM SysLookupsValues_Backup 
		GROUP BY Id) AS firstLogValue
	WHERE slvb.Id = firstLogValue.Id
		AND slvb.CreatedOn = firstLogValue.CreatedOn;

OPEN restoreLookupCursor;
FETCH NEXT 
	FROM restoreLookupCursor 
	INTO @Id, @Name, @TableName
WHILE @@FETCH_STATUS = 0
BEGIN
	SET @DropTriggerCmd = REPLACE(@DropTriggerCmdTemplate, '{TableName}', @TableName);
	EXEC (@DropTriggerCmd);

	SET @UpdateCmd = REPLACE(@UpdateCmdTemplate, '@TableName', QUOTENAME(@TableName));
	SET @UpdateCmd = REPLACE(@UpdateCmd, '@Name', REPLACE(@Name, CHAR(39), CHAR(39) + CHAR(39)));
	SET @UpdateCmd = REPLACE(@UpdateCmd, '@Id', CAST(@Id AS VARCHAR(36)));
	BEGIN TRY
		PRINT (@UpdateCmd);
		EXEC (@UpdateCmd);
	END TRY
	BEGIN CATCH 
		PRINT ERROR_MESSAGE() + ' while update lookup table '+ @Name;
	END CATCH
	FETCH NEXT FROM restoreLookupCursor
		INTO @Id, @Name, @TableName;
END
DEALLOCATE restoreLookupCursor;