﻿IF (SELECT TOP (1) 1 FROM SysLic) IS NULL
	RETURN;

-- Restore SysSettings values
DECLARE @forceUpdateSysSettingsCode AS TABLE (Code NVARCHAR(500));
INSERT INTO @forceUpdateSysSettingsCode (Code)
VALUES ('WelcomeScreenVideoUrl'),
		('ConfigurationVersion'),
		('ApiUrl'),
		('ScriptTemplate'),
		('PeriodActualizeBulkEmailRecipients'),
		('SalesDashboardsWithPrefix'),
		('SalesDashboardPrefix'),
		('CaseOrigin'),
		('CaseStatus'),
		('CasePriority'),
		('SatisfactionLevel'),
		('FieldForcePackageUrl');

IF OBJECT_ID('CheckSysSettingsValueUpdate') IS NOT NULL
BEGIN
	PRINT('DROP TRIGGER CheckSysSettingsValueUpdate');
	DROP TRIGGER CheckSysSettingsValueUpdate;
END

UPDATE SysSettingsValue
SET
	SysAdminUnitId = ussvl.[SysAdminUnitId],
	[IsDef] = ussvl.[IsDef], 
	[TextValue] = ussvl.[TextValue], 
	[IntegerValue] = ussvl.[IntegerValue], 
	[FloatValue] = ussvl.[FloatValue],
	[BooleanValue] = ussvl.[BooleanValue],
	[DateTimeValue] = ussvl.[DateTimeValue],
	[GuidValue] = ussvl.[GuidValue],
	[BinaryValue] = ussvl.[BinaryValue]
FROM SysSettingsValue ssv
INNER JOIN
	(SELECT
		innerLogValue.*
	FROM UpdatedSysSettingsValuesLog innerLogValue,
		(SELECT SysSettingsId,
			MIN(CreatedOn) AS CreatedOn
			FROM UpdatedSysSettingsValuesLog
			GROUP BY SysSettingsId) AS firstLogValue
	WHERE
		innerLogValue.SysSettingsId = firstLogValue.SysSettingsId
		AND innerLogValue.CreatedOn = firstLogValue.CreatedOn) ussvl
	ON ussvl.Id = ssv.Id
INNER JOIN SysSettings ss ON ss.Id = ssv.SysSettingsId
WHERE (
	ussvl.[SysAdminUnitId] <> ssv.[SysAdminUnitId]
	OR ussvl.[IsDef] <> ssv.[IsDef]
	OR ussvl.[TextValue] <> ssv.[TextValue]
	OR ussvl.[IntegerValue] <> ssv.[IntegerValue]
	OR ussvl.[FloatValue] <> ssv.[FloatValue]
	OR ussvl.[BooleanValue] <> ssv.[BooleanValue]
	OR ussvl.[DateTimeValue] <> ssv.[DateTimeValue]
	OR ussvl.[GuidValue] <> ssv.[GuidValue]
	OR ussvl.[BinaryValue] <> ssv.[BinaryValue])
	AND Code NOT IN (SELECT Code FROM @forceUpdateSysSettingsCode
);