﻿IF (SELECT TOP (1) 1 FROM SysLic) IS NULL
	RETURN;

IF OBJECT_ID('UpdatedSysSettingsValuesLog') IS NOT NULL
	DROP TABLE UpdatedSysSettingsValuesLog;

CREATE TABLE UpdatedSysSettingsValuesLog (
	Id UNIQUEIDENTIFIER NOT NULL DEFAULT NEWID(),
	SysSettingsId UNIQUEIDENTIFIER NULL,
	SysAdminUnitId UNIQUEIDENTIFIER NULL,
	IsDef BIT NOT NULL DEFAULT (0),
	TextValue NVARCHAR(MAX) NOT NULL DEFAULT (''),
	IntegerValue INT NOT NULL DEFAULT (0),
	FloatValue DECIMAL(18, 2) NOT NULL DEFAULT (0),
	BooleanValue BIT NOT NULL DEFAULT (0),
	DateTimeValue DATETIME2(3) NULL,
	GuidValue UNIQUEIDENTIFIER NULL,
	BinaryValue VARBINARY(MAX) NULL,
	CreatedOn DATETIME2(3)
);

IF OBJECT_ID('CheckSysSettingsValueUpdate') IS NOT NULL
	DROP TRIGGER CheckSysSettingsValueUpdate;

DECLARE @cmdSysSettingsCreateTrigger NVARCHAR(MAX) =
'CREATE TRIGGER CheckSysSettingsValueUpdate
ON SysSettingsValue
FOR UPDATE
AS
BEGIN
	SET NOCOUNT ON;
	INSERT INTO UpdatedSysSettingsValuesLog
		(Id, SysSettingsId, SysAdminUnitId, IsDef, TextValue, IntegerValue, FloatValue, BooleanValue, DateTimeValue, GuidValue, BinaryValue, CreatedOn)
	SELECT
		Id, SysSettingsId, SysAdminUnitId, IsDef, TextValue, IntegerValue, FloatValue, BooleanValue, DateTimeValue, GuidValue, BinaryValue, GETDATE()
	FROM DELETED
END';
EXEC (@cmdSysSettingsCreateTrigger);