DECLARE @brokenCampaignsCount INT = 0;

IF OBJECT_ID('Campaign', N'U') IS NULL 
	OR OBJECT_ID('CampaignParticipant', N'U') IS NULL
BEGIN
	RETURN;
END;

IF OBJECT_ID('tempdb..#CampaignIdsWithEmptyContactParticipants') IS NOT NULL
BEGIN
	DROP TABLE #CampaignIdsWithEmptyContactParticipants
END;

SELECT DISTINCT CampaignId 
	INTO #CampaignIdsWithEmptyContactParticipants 
FROM [CampaignParticipant]
WHERE [ContactId] is null

SET @brokenCampaignsCount = (SELECT Count(*) FROM #CampaignIdsWithEmptyContactParticipants);

WHILE @brokenCampaignsCount > 0
BEGIN
	DECLARE @campaignId UNIQUEIDENTIFIER;
	DECLARE @brokenParticipantsCount INT = 0;
	SET @campaignId = (SELECT TOP 1 CampaignId FROM #CampaignIdsWithEmptyContactParticipants);
	SET @brokenParticipantsCount = (
		SELECT Count(*)
		FROM CampaignParticipant
		WHERE CampaignId = @campaignId
			AND ContactId IS NULL);
	UPDATE Campaign
		SET TargetTotal = TargetTotal - @brokenParticipantsCount
		WHERE Id = @campaignId;
	DELETE FROM CampaignParticipant
		WHERE CampaignId = @campaignId AND ContactId IS NULL;
	DELETE FROM #CampaignIdsWithEmptyContactParticipants
		WHERE CampaignId = @campaignId;
	SET @brokenCampaignsCount = @brokenCampaignsCount - 1;
END;
