IF OBJECT_ID (N'BulkEmail', N'U') IS NOT NULL 
BEGIN

DECLARE @DuplicateEmailResponseId uniqueidentifier = '290F4FDB-D628-4049-BBD4-77572845BA33';
DECLARE @BlunkEmailResponseId uniqueidentifier = '8FFDE5F0-CB75-4D90-A757-7E4748491ABF';
DECLARE @UnreachableEmailResponseId uniqueidentifier = '59ACDA79-1ACD-47CC-8655-8E74BD2D00D0';
DECLARE @IncorrectEmailResponseId uniqueidentifier = 'F83922C2-C8A3-4DD0-A688-D59A41E1AB2B';
DECLARE @DoNotUseEmailResponseId uniqueidentifier = 'BBFB3947-54FF-48C0-A1E5-F46F01A54E6D';

UPDATE BulkEmail
SET BlankEmailCount = counters.BlankCount,
 IncorrectEmailCount = counters.IncorrectCount,
 UnreachableEmailCount = counters.UnreachableCount,
 DoNotUseEmailCount = counters.DoNotUseCount,
 DuplicateEmailCount = counters.DuplicateCount
FROM (
SELECT
	tmp.BulkEmailId
   ,SUM(tmp.DuplicateEmail) as DuplicateCount
   ,SUM(tmp.BlankEmail) as BlankCount
   ,SUM(tmp.UnreachableEmail) as UnreachableCount
   ,SUM(tmp.IncorrectEmail) as IncorrectCount
   ,SUM(tmp.DoNotUseEmail) as DoNotUseCount
FROM (SELECT
		bet.BulkEmailId AS BulkEmailId
	   ,CASE
			WHEN bet.BulkEmailResponseId = @DuplicateEmailResponseId THEN 1
			ELSE 0
		END DuplicateEmail
	   ,CASE
			WHEN bet.BulkEmailResponseId = @BlunkEmailResponseId THEN 1
			ELSE 0
		END BlankEmail
	   ,CASE
			WHEN bet.BulkEmailResponseId = @UnreachableEmailResponseId THEN 1
			ELSE 0
		END UnreachableEmail
	   ,CASE
			WHEN bet.BulkEmailResponseId = @IncorrectEmailResponseId THEN 1
			ELSE 0
		END IncorrectEmail
	   ,CASE
			WHEN bet.BulkEmailResponseId = @DoNotUseEmailResponseId THEN 1
			ELSE 0
		END DoNotUseEmail
	FROM BulkEmailTarget bet) AS tmp
GROUP BY BulkEmailId) as counters
WHERE   DuplicateEmailCount = 0 AND
  UnreachableEmailCount = 0 AND
  BlankEmailCount = 0 AND
  IncorrectEmailCount = 0 AND
  DoNotUseEmailCount = 0 AND
Id = counters.BulkEmailId

END