DECLARE @ProperTemplates TABLE (BulkEmailId uniqueidentifier);
BEGIN
	IF OBJECT_ID('BulkEmail') IS NULL
	BEGIN
		RETURN;
	END;
	BEGIN TRANSACTION;
		BEGIN TRY

			INSERT INTO @ProperTemplates (BulkEmailId)
			SELECT c.Id
			FROM (
					SELECT be.Id
					FROM SysBulkEmailLcz lc WITH (NOLOCK)
							INNER JOIN BulkEmail be WITH (NOLOCK) on be.Id = lc.RecordId
					WHERE lc.templatebody NOT LIKE 
						'%9sAQwARDAwMDQwRDQ0RGRAOEBkdFhERFh0iFxcXFxciIRodHBwdGiEhJigrKCYhNDQ4ODQ0QUFBQUFBQUFBQUFBQUFB/9sAQwESEBATFRMXFBQXFhIVEhYcFhgYFhwpHBweHBwpNSYhISEhJjUvMisrKzIvOTk1NTk5QUFBQUFBQUFBQUFBQUFB%'
						AND be.TemplateBody LIKE
						'%9sAQwARDAwMDQwRDQ0RGRAOEBkdFhERFh0iFxcXFxciIRodHBwdGiEhJigrKCYhNDQ4ODQ0QUFBQUFBQUFBQUFBQUFB/9sAQwESEBATFRMXFBQXFhIVEhYcFhgYFhwpHBweHBwpNSYhISEhJjUvMisrKzIvOTk1NTk5QUFBQUFBQUFBQUFBQUFB%'
					GROUP BY be.Id, lc.TemplateBody ) c
			GROUP BY c.Id
			HAVING COUNT(c.Id) = 1;

			UPDATE BulkEmail
			SET BulkEmail.TemplateBody = a.TemplateBody
			FROM (SELECT TOP 1 t.BulkEmailId Id, lc.TemplateBody
					FROM @ProperTemplates t
						INNER JOIN SysBulkEmailLcz lc on t.BulkEmailId = lc.RecordId) a
			WHERE BulkEmail.Id = a.Id;

		END TRY
		BEGIN CATCH
			IF @@TRANCOUNT > 0
			BEGIN
				ROLLBACK TRANSACTION;
			END;
		END CATCH;
	IF @@TRANCOUNT > 0
	BEGIN
		COMMIT TRANSACTION;
	END;
END;